/* Synopsis: Passage a niveau avant stockage
   Carte   : Arduino Nano
   Capteur : Capteurs ILS  
             
  Biblio:  Servo.h 
             
  Source:  https://www.locoduino.org/spip.php?article262
           https://www.locoduino.org/spip.php?article62
           https://www.volta.ma/comment-controler-les-servomoteurs-avec-arduino/arduino/
           https://www.carnetdumaker.net/articles/controler-un-servomoteur-avec-une-carte-arduino-genuino/
           https://eskimon.fr/tuto-arduino-602-un-moteur-qui-a-de-la-tête-le-servomoteur
           https://zestedesavoir.com/tutoriels/686/arduino-premiers-pas-en-informatique-embarquee/747_le-mouvement-grace-aux-moteurs/3438_un-moteur-qui-a-de-la-tete-le-servomoteur/
           
   https://electroniquepassion.fr/ 
   C.Mercier  62128 Boiry-Becquerelle  
*/
//-----------------------------------------------------------------
#include <Servo.h>
Servo monServo1;
Servo monServo2;
int vitesse;
int angle1;
int angle2;
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
544µs donnera un angle de 0° et une valeur de 2400µs donnera un angle de 180°.
A verifier avec le datasheet du servomoteur
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
const int ANGLE_MIN1  = 1400;//  Modifie le 26/12/2023
const int ANGLE_MAX1 = 1998;// 2000 Modifie le 07/08/2024
const int ANGLE_MIN2  = 1400;// 1300 Modifie le 07/08/2024
const int ANGLE_MAX2 = 1998;// 2000 Modifie le 07/08/2024
const int ANGLE1_SOUSTENSION = 1998;// 1500 Modifie le 07/08/2024
const int ANGLE2_SOUSTENSION = 1998;// 1500 Modifie le 07/08/2024

bool cdeServos;

const int DET1 = A0;
const int DET2 = A1;

const byte LED_ZONE_OCCUPEE = 13;// Utilisee pour informtion zone occupee
bool memDet1;
bool memDet2;

unsigned long compteurTempsFermetureBarrieres = 0;
unsigned long compteurTempsOuvertureBarrieres = 0;
int retardFermetureBarrieres = 800;//  Temps avant fermeture en ms
int retardOuvertureBarrieres = 800;//  Temps avant ouverture en ms

bool fermetureBarrieres = 0;
bool ouvertureBarrieres = 0;
bool zoneOccupee = 0;// Zone entre les deux capteurs
int etatDet1 = 1023;
int etatDet2 = 1023;

const byte FLASH= 3;// Port PD
const byte DEL_SW1_SW2 = 2;
unsigned long compteurTempsLeds = 0; //  Variable pour compter le temps pour faire clignoter à intervale fixe les leds
bool flipFlop = 0;// Allumage Leds

unsigned long tempsCourant = 0;
unsigned long tempsPULS_D11 = 500;
const byte PULS_D11 = 11;// Pilotage circuit son
bool memPulsD11 = 0; 
//--------------------------------------------
void setup()
{
monServo1.attach(4);// Port PD
monServo2.attach(8);// Port PB
angle1 = ANGLE_MIN1;
angle2 = ANGLE_MIN2;
vitesse = 4;
/*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
544µs donnera un angle de 0° et une valeur de 2400µs donnera un angle de 180°.
A verifier avec le datasheet du servomoteur
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
monServo1.writeMicroseconds(ANGLE1_SOUSTENSION);
monServo2.writeMicroseconds(ANGLE2_SOUSTENSION);

pinMode(DET1, INPUT);// Detecteur avant passage a niveau
pinMode(DET2, INPUT);// Detecteur apres passage a niveau
pinMode(FLASH, OUTPUT);
pinMode(DEL_SW1_SW2, OUTPUT);
pinMode(LED_ZONE_OCCUPEE, OUTPUT);
pinMode(PULS_D11, OUTPUT);

digitalWrite(FLASH,HIGH);
digitalWrite(DEL_SW1_SW2,HIGH);
digitalWrite(LED_ZONE_OCCUPEE,LOW);
digitalWrite(PULS_D11, HIGH);
memDet1 = 0;
memDet2 = 1;

Serial.begin(9600); 
delay(5000);

}//FIN_SETUP
//--------------------------------------------
void loop()
{
etatDet1 = analogRead(DET1);
etatDet2 = analogRead(DET2);
//--------------------------------------------
  if(etatDet1 <= 512 && zoneOccupee == 0 && memDet2 == 1)
    {
      memDet1 = 1;
      memDet2 = 0;
      zoneOccupee = 1;
    }
//--------------------------------------------    
  if(etatDet2 <= 512 && zoneOccupee == 0 && memDet1 == 1)
    {
      memDet2 = 1;
      memDet1 = 0;
      zoneOccupee = 1;
    }
//--------------------------------------------
  if ((etatDet1 <= 512 && memDet1 == 1) || (etatDet2 <= 512 && memDet2 == 1) )
    {         
        fermetureBarrieres = 1;
        compteurTempsFermetureBarrieres = millis();         
    }
  if(fermetureBarrieres == 1)
    {
       if((millis()-compteurTempsFermetureBarrieres) >= retardFermetureBarrieres)
        { 
          fermetureBarrieres = 0; 
          cdeServos = 1; 
        }  
    }
//--------------------------------------------
  if ((etatDet2 <= 512 && zoneOccupee == 1 && memDet1 == 1) || (etatDet1 <= 512 && zoneOccupee == 1 && memDet2 == 1))
    {         
        ouvertureBarrieres = 1;
        compteurTempsOuvertureBarrieres = millis();         
    }
  if(ouvertureBarrieres == 1)
    {
       if((millis()-compteurTempsOuvertureBarrieres) >= retardOuvertureBarrieres)
        { 
          ouvertureBarrieres = 0; 
          zoneOccupee = 0;
          cdeServos = 0;
        }  
    }
//--------------------------------------------
  if(zoneOccupee == 1) 
    {  
      digitalWrite(LED_ZONE_OCCUPEE,HIGH);
      Signal();// appel fonction Leds
    }      
  else
    {
      digitalWrite(LED_ZONE_OCCUPEE,LOW);
      digitalWrite(FLASH,HIGH);
    } 
//--------------------------------------------
  if(cdeServos == 1)
    {
      //ServosFermeture1();//  Modifie le 26/12/2023
      //ServosFermeture2();//  Modifie le 26/12/2023
      ServosOuverture1();
      ServosOuverture2();
      delay(2);
    }
//--------------------------------------------
  if(cdeServos == 0)
    {
      //ServosOuverture1();//  Modifie le 26/12/2023
      //ServosOuverture2();//  Modifie le 26/12/2023
      ServosFermeture1();
      ServosFermeture2();
      delay(2);
    }
//--------------------------------------------
if(etatDet1 < 512 || etatDet2 < 512) 
  {
    digitalWrite(DEL_SW1_SW2,LOW);
  }  
else
  {
    digitalWrite(DEL_SW1_SW2,HIGH);
  }
pulsD11();  
//--------------------------------------------
//Serial.print(etatDet1);
//Serial.print("\t");
//Serial.print(etatDet2);
//Serial.print("\t");
//Serial.print(memDet1);
//Serial.print("\t");
//Serial.print(memDet2);
//Serial.print("\t");
Serial.print(cdeServos);
Serial.print("\t");
Serial.print("\t");
Serial.print(angle1);
Serial.print("\t");
Serial.println(angle2);
//Serial.print("\t");
//Serial.println(zoneOccupee);
}//FIN_LOOP
//--------------------------------------------
void ServosFermeture1()
{
monServo1.writeMicroseconds(angle1);
/* calcule le nouvel angle */
angle1 = angle1 + vitesse;
 
  if (angle1 > ANGLE_MAX1)
    {
      angle1 = ANGLE_MAX1;
    }
//delay(2);    
}  
//--------------------------------------------
void ServosOuverture1()
{
monServo1.writeMicroseconds(angle1);
/* calcule le nouvel angle */
angle1 = angle1 - vitesse;

  if (angle1 < ANGLE_MIN1)
    {
      angle1 = ANGLE_MIN1;
    }
//delay(2);    
}  
//--------------------------------------------
void ServosFermeture2()
{
monServo2.writeMicroseconds(angle2);
/* calcule le nouvel angle */
angle2 = angle2 + vitesse;
 
  if (angle2 > ANGLE_MAX2)
    {
      angle2 = ANGLE_MAX2;
    }
//delay(2);    
}  
//--------------------------------------------
void ServosOuverture2()
{
monServo2.writeMicroseconds(angle2);
/* calcule le nouvel angle */
angle2 = angle2 - vitesse;

  if (angle2 < ANGLE_MIN2)
    {
      angle2 = ANGLE_MIN2;
    }
//delay(2);    
}  
//------Fonction leds-------
void Signal()
{
  if (millis() > compteurTempsLeds + 500)
    {
      compteurTempsLeds = millis();
        if (flipFlop == false)
         {
          flipFlop = true;
          digitalWrite(FLASH,HIGH);         
         } 
        else
         {
          flipFlop = false;
          digitalWrite(FLASH,LOW);          
         }
    }
}
void pulsD11()
{
  if(zoneOccupee == 1 && memPulsD11 == 0)
  {
    digitalWrite(PULS_D11, LOW);
    memPulsD11 = 1;
    tempsCourant = millis();
  }  
  if(millis() - tempsCourant >= tempsPULS_D11)
    {
      digitalWrite(PULS_D11, HIGH);         
    }      
  if(zoneOccupee == 0)
    {
      memPulsD11 = 0;    
    }  
}